// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: chaos/serverexperimentation/v1/serverexperimentation.proto

package serverexperimentationv1

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"sort"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
	_ = sort.Sort
)

// Validate checks the field values on HTTPFaultConfig with the rules defined
// in the proto definition for this message. If any rules are violated, the
// first error encountered is returned, or nil if there are no violations.
func (m *HTTPFaultConfig) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on HTTPFaultConfig with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// HTTPFaultConfigMultiError, or nil if none found.
func (m *HTTPFaultConfig) ValidateAll() error {
	return m.validate(true)
}

func (m *HTTPFaultConfig) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if m.GetFaultTargeting() == nil {
		err := HTTPFaultConfigValidationError{
			field:  "FaultTargeting",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if all {
		switch v := interface{}(m.GetFaultTargeting()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, HTTPFaultConfigValidationError{
					field:  "FaultTargeting",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, HTTPFaultConfigValidationError{
					field:  "FaultTargeting",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetFaultTargeting()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return HTTPFaultConfigValidationError{
				field:  "FaultTargeting",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	switch m.Fault.(type) {

	case *HTTPFaultConfig_AbortFault:

		if all {
			switch v := interface{}(m.GetAbortFault()).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, HTTPFaultConfigValidationError{
						field:  "AbortFault",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, HTTPFaultConfigValidationError{
						field:  "AbortFault",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(m.GetAbortFault()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return HTTPFaultConfigValidationError{
					field:  "AbortFault",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	case *HTTPFaultConfig_LatencyFault:

		if all {
			switch v := interface{}(m.GetLatencyFault()).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, HTTPFaultConfigValidationError{
						field:  "LatencyFault",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, HTTPFaultConfigValidationError{
						field:  "LatencyFault",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(m.GetLatencyFault()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return HTTPFaultConfigValidationError{
					field:  "LatencyFault",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	default:
		err := HTTPFaultConfigValidationError{
			field:  "Fault",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)

	}

	if len(errors) > 0 {
		return HTTPFaultConfigMultiError(errors)
	}
	return nil
}

// HTTPFaultConfigMultiError is an error wrapping multiple validation errors
// returned by HTTPFaultConfig.ValidateAll() if the designated constraints
// aren't met.
type HTTPFaultConfigMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m HTTPFaultConfigMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m HTTPFaultConfigMultiError) AllErrors() []error { return m }

// HTTPFaultConfigValidationError is the validation error returned by
// HTTPFaultConfig.Validate if the designated constraints aren't met.
type HTTPFaultConfigValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e HTTPFaultConfigValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e HTTPFaultConfigValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e HTTPFaultConfigValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e HTTPFaultConfigValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e HTTPFaultConfigValidationError) ErrorName() string { return "HTTPFaultConfigValidationError" }

// Error satisfies the builtin error interface
func (e HTTPFaultConfigValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sHTTPFaultConfig.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = HTTPFaultConfigValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = HTTPFaultConfigValidationError{}

// Validate checks the field values on AbortFault with the rules defined in the
// proto definition for this message. If any rules are violated, the first
// error encountered is returned, or nil if there are no violations.
func (m *AbortFault) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on AbortFault with the rules defined in
// the proto definition for this message. If any rules are violated, the
// result is a list of violation errors wrapped in AbortFaultMultiError, or
// nil if none found.
func (m *AbortFault) ValidateAll() error {
	return m.validate(true)
}

func (m *AbortFault) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if m.GetPercentage() == nil {
		err := AbortFaultValidationError{
			field:  "Percentage",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if all {
		switch v := interface{}(m.GetPercentage()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, AbortFaultValidationError{
					field:  "Percentage",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, AbortFaultValidationError{
					field:  "Percentage",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetPercentage()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return AbortFaultValidationError{
				field:  "Percentage",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if m.GetAbortStatus() == nil {
		err := AbortFaultValidationError{
			field:  "AbortStatus",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if all {
		switch v := interface{}(m.GetAbortStatus()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, AbortFaultValidationError{
					field:  "AbortStatus",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, AbortFaultValidationError{
					field:  "AbortStatus",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetAbortStatus()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return AbortFaultValidationError{
				field:  "AbortStatus",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if len(errors) > 0 {
		return AbortFaultMultiError(errors)
	}
	return nil
}

// AbortFaultMultiError is an error wrapping multiple validation errors
// returned by AbortFault.ValidateAll() if the designated constraints aren't met.
type AbortFaultMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m AbortFaultMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m AbortFaultMultiError) AllErrors() []error { return m }

// AbortFaultValidationError is the validation error returned by
// AbortFault.Validate if the designated constraints aren't met.
type AbortFaultValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e AbortFaultValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e AbortFaultValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e AbortFaultValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e AbortFaultValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e AbortFaultValidationError) ErrorName() string { return "AbortFaultValidationError" }

// Error satisfies the builtin error interface
func (e AbortFaultValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sAbortFault.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = AbortFaultValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = AbortFaultValidationError{}

// Validate checks the field values on LatencyFault with the rules defined in
// the proto definition for this message. If any rules are violated, the first
// error encountered is returned, or nil if there are no violations.
func (m *LatencyFault) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on LatencyFault with the rules defined
// in the proto definition for this message. If any rules are violated, the
// result is a list of violation errors wrapped in LatencyFaultMultiError, or
// nil if none found.
func (m *LatencyFault) ValidateAll() error {
	return m.validate(true)
}

func (m *LatencyFault) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if m.GetPercentage() == nil {
		err := LatencyFaultValidationError{
			field:  "Percentage",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if all {
		switch v := interface{}(m.GetPercentage()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, LatencyFaultValidationError{
					field:  "Percentage",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, LatencyFaultValidationError{
					field:  "Percentage",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetPercentage()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return LatencyFaultValidationError{
				field:  "Percentage",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if m.GetLatencyDuration() == nil {
		err := LatencyFaultValidationError{
			field:  "LatencyDuration",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if all {
		switch v := interface{}(m.GetLatencyDuration()).(type) {
		case interface{ ValidateAll() error }:
			if err := v.ValidateAll(); err != nil {
				errors = append(errors, LatencyFaultValidationError{
					field:  "LatencyDuration",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		case interface{ Validate() error }:
			if err := v.Validate(); err != nil {
				errors = append(errors, LatencyFaultValidationError{
					field:  "LatencyDuration",
					reason: "embedded message failed validation",
					cause:  err,
				})
			}
		}
	} else if v, ok := interface{}(m.GetLatencyDuration()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return LatencyFaultValidationError{
				field:  "LatencyDuration",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if len(errors) > 0 {
		return LatencyFaultMultiError(errors)
	}
	return nil
}

// LatencyFaultMultiError is an error wrapping multiple validation errors
// returned by LatencyFault.ValidateAll() if the designated constraints aren't met.
type LatencyFaultMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m LatencyFaultMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m LatencyFaultMultiError) AllErrors() []error { return m }

// LatencyFaultValidationError is the validation error returned by
// LatencyFault.Validate if the designated constraints aren't met.
type LatencyFaultValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e LatencyFaultValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e LatencyFaultValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e LatencyFaultValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e LatencyFaultValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e LatencyFaultValidationError) ErrorName() string { return "LatencyFaultValidationError" }

// Error satisfies the builtin error interface
func (e LatencyFaultValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sLatencyFault.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = LatencyFaultValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = LatencyFaultValidationError{}

// Validate checks the field values on FaultTargeting with the rules defined in
// the proto definition for this message. If any rules are violated, the first
// error encountered is returned, or nil if there are no violations.
func (m *FaultTargeting) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on FaultTargeting with the rules defined
// in the proto definition for this message. If any rules are violated, the
// result is a list of violation errors wrapped in FaultTargetingMultiError,
// or nil if none found.
func (m *FaultTargeting) ValidateAll() error {
	return m.validate(true)
}

func (m *FaultTargeting) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	switch m.Enforcer.(type) {

	case *FaultTargeting_UpstreamEnforcing:

		if all {
			switch v := interface{}(m.GetUpstreamEnforcing()).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, FaultTargetingValidationError{
						field:  "UpstreamEnforcing",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, FaultTargetingValidationError{
						field:  "UpstreamEnforcing",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(m.GetUpstreamEnforcing()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return FaultTargetingValidationError{
					field:  "UpstreamEnforcing",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	case *FaultTargeting_DownstreamEnforcing:

		if all {
			switch v := interface{}(m.GetDownstreamEnforcing()).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, FaultTargetingValidationError{
						field:  "DownstreamEnforcing",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, FaultTargetingValidationError{
						field:  "DownstreamEnforcing",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(m.GetDownstreamEnforcing()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return FaultTargetingValidationError{
					field:  "DownstreamEnforcing",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	default:
		err := FaultTargetingValidationError{
			field:  "Enforcer",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)

	}

	if len(errors) > 0 {
		return FaultTargetingMultiError(errors)
	}
	return nil
}

// FaultTargetingMultiError is an error wrapping multiple validation errors
// returned by FaultTargeting.ValidateAll() if the designated constraints
// aren't met.
type FaultTargetingMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m FaultTargetingMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m FaultTargetingMultiError) AllErrors() []error { return m }

// FaultTargetingValidationError is the validation error returned by
// FaultTargeting.Validate if the designated constraints aren't met.
type FaultTargetingValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e FaultTargetingValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e FaultTargetingValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e FaultTargetingValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e FaultTargetingValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e FaultTargetingValidationError) ErrorName() string { return "FaultTargetingValidationError" }

// Error satisfies the builtin error interface
func (e FaultTargetingValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sFaultTargeting.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = FaultTargetingValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = FaultTargetingValidationError{}

// Validate checks the field values on UpstreamEnforcing with the rules defined
// in the proto definition for this message. If any rules are violated, the
// first error encountered is returned, or nil if there are no violations.
func (m *UpstreamEnforcing) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on UpstreamEnforcing with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// UpstreamEnforcingMultiError, or nil if none found.
func (m *UpstreamEnforcing) ValidateAll() error {
	return m.validate(true)
}

func (m *UpstreamEnforcing) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	switch m.UpstreamType.(type) {

	case *UpstreamEnforcing_UpstreamCluster:

		if all {
			switch v := interface{}(m.GetUpstreamCluster()).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, UpstreamEnforcingValidationError{
						field:  "UpstreamCluster",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, UpstreamEnforcingValidationError{
						field:  "UpstreamCluster",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(m.GetUpstreamCluster()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return UpstreamEnforcingValidationError{
					field:  "UpstreamCluster",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	default:
		err := UpstreamEnforcingValidationError{
			field:  "UpstreamType",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)

	}

	switch m.DownstreamType.(type) {

	case *UpstreamEnforcing_DownstreamCluster:

		if all {
			switch v := interface{}(m.GetDownstreamCluster()).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, UpstreamEnforcingValidationError{
						field:  "DownstreamCluster",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, UpstreamEnforcingValidationError{
						field:  "DownstreamCluster",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(m.GetDownstreamCluster()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return UpstreamEnforcingValidationError{
					field:  "DownstreamCluster",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	default:
		err := UpstreamEnforcingValidationError{
			field:  "DownstreamType",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)

	}

	if len(errors) > 0 {
		return UpstreamEnforcingMultiError(errors)
	}
	return nil
}

// UpstreamEnforcingMultiError is an error wrapping multiple validation errors
// returned by UpstreamEnforcing.ValidateAll() if the designated constraints
// aren't met.
type UpstreamEnforcingMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m UpstreamEnforcingMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m UpstreamEnforcingMultiError) AllErrors() []error { return m }

// UpstreamEnforcingValidationError is the validation error returned by
// UpstreamEnforcing.Validate if the designated constraints aren't met.
type UpstreamEnforcingValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e UpstreamEnforcingValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e UpstreamEnforcingValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e UpstreamEnforcingValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e UpstreamEnforcingValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e UpstreamEnforcingValidationError) ErrorName() string {
	return "UpstreamEnforcingValidationError"
}

// Error satisfies the builtin error interface
func (e UpstreamEnforcingValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sUpstreamEnforcing.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = UpstreamEnforcingValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = UpstreamEnforcingValidationError{}

// Validate checks the field values on DownstreamEnforcing with the rules
// defined in the proto definition for this message. If any rules are
// violated, the first error encountered is returned, or nil if there are no violations.
func (m *DownstreamEnforcing) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on DownstreamEnforcing with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// DownstreamEnforcingMultiError, or nil if none found.
func (m *DownstreamEnforcing) ValidateAll() error {
	return m.validate(true)
}

func (m *DownstreamEnforcing) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	switch m.UpstreamType.(type) {

	case *DownstreamEnforcing_UpstreamCluster:

		if all {
			switch v := interface{}(m.GetUpstreamCluster()).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, DownstreamEnforcingValidationError{
						field:  "UpstreamCluster",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, DownstreamEnforcingValidationError{
						field:  "UpstreamCluster",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(m.GetUpstreamCluster()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return DownstreamEnforcingValidationError{
					field:  "UpstreamCluster",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	default:
		err := DownstreamEnforcingValidationError{
			field:  "UpstreamType",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)

	}

	switch m.DownstreamType.(type) {

	case *DownstreamEnforcing_DownstreamCluster:

		if all {
			switch v := interface{}(m.GetDownstreamCluster()).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, DownstreamEnforcingValidationError{
						field:  "DownstreamCluster",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, DownstreamEnforcingValidationError{
						field:  "DownstreamCluster",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(m.GetDownstreamCluster()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return DownstreamEnforcingValidationError{
					field:  "DownstreamCluster",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	default:
		err := DownstreamEnforcingValidationError{
			field:  "DownstreamType",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)

	}

	if len(errors) > 0 {
		return DownstreamEnforcingMultiError(errors)
	}
	return nil
}

// DownstreamEnforcingMultiError is an error wrapping multiple validation
// errors returned by DownstreamEnforcing.ValidateAll() if the designated
// constraints aren't met.
type DownstreamEnforcingMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m DownstreamEnforcingMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m DownstreamEnforcingMultiError) AllErrors() []error { return m }

// DownstreamEnforcingValidationError is the validation error returned by
// DownstreamEnforcing.Validate if the designated constraints aren't met.
type DownstreamEnforcingValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e DownstreamEnforcingValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e DownstreamEnforcingValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e DownstreamEnforcingValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e DownstreamEnforcingValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e DownstreamEnforcingValidationError) ErrorName() string {
	return "DownstreamEnforcingValidationError"
}

// Error satisfies the builtin error interface
func (e DownstreamEnforcingValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sDownstreamEnforcing.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = DownstreamEnforcingValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = DownstreamEnforcingValidationError{}

// Validate checks the field values on SingleCluster with the rules defined in
// the proto definition for this message. If any rules are violated, the first
// error encountered is returned, or nil if there are no violations.
func (m *SingleCluster) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on SingleCluster with the rules defined
// in the proto definition for this message. If any rules are violated, the
// result is a list of violation errors wrapped in SingleClusterMultiError, or
// nil if none found.
func (m *SingleCluster) ValidateAll() error {
	return m.validate(true)
}

func (m *SingleCluster) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if len(m.GetName()) < 1 {
		err := SingleClusterValidationError{
			field:  "Name",
			reason: "value length must be at least 1 bytes",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if len(errors) > 0 {
		return SingleClusterMultiError(errors)
	}
	return nil
}

// SingleClusterMultiError is an error wrapping multiple validation errors
// returned by SingleCluster.ValidateAll() if the designated constraints
// aren't met.
type SingleClusterMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m SingleClusterMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m SingleClusterMultiError) AllErrors() []error { return m }

// SingleClusterValidationError is the validation error returned by
// SingleCluster.Validate if the designated constraints aren't met.
type SingleClusterValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e SingleClusterValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e SingleClusterValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e SingleClusterValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e SingleClusterValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e SingleClusterValidationError) ErrorName() string { return "SingleClusterValidationError" }

// Error satisfies the builtin error interface
func (e SingleClusterValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sSingleCluster.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = SingleClusterValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = SingleClusterValidationError{}

// Validate checks the field values on ClusterPercentage with the rules defined
// in the proto definition for this message. If any rules are violated, the
// first error encountered is returned, or nil if there are no violations.
func (m *ClusterPercentage) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on ClusterPercentage with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// ClusterPercentageMultiError, or nil if none found.
func (m *ClusterPercentage) ValidateAll() error {
	return m.validate(true)
}

func (m *ClusterPercentage) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if val := m.GetPercentage(); val <= 0 || val > 100 {
		err := ClusterPercentageValidationError{
			field:  "Percentage",
			reason: "value must be inside range (0, 100]",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if len(errors) > 0 {
		return ClusterPercentageMultiError(errors)
	}
	return nil
}

// ClusterPercentageMultiError is an error wrapping multiple validation errors
// returned by ClusterPercentage.ValidateAll() if the designated constraints
// aren't met.
type ClusterPercentageMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m ClusterPercentageMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m ClusterPercentageMultiError) AllErrors() []error { return m }

// ClusterPercentageValidationError is the validation error returned by
// ClusterPercentage.Validate if the designated constraints aren't met.
type ClusterPercentageValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ClusterPercentageValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ClusterPercentageValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ClusterPercentageValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ClusterPercentageValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ClusterPercentageValidationError) ErrorName() string {
	return "ClusterPercentageValidationError"
}

// Error satisfies the builtin error interface
func (e ClusterPercentageValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sClusterPercentage.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ClusterPercentageValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ClusterPercentageValidationError{}

// Validate checks the field values on FaultPercentage with the rules defined
// in the proto definition for this message. If any rules are violated, the
// first error encountered is returned, or nil if there are no violations.
func (m *FaultPercentage) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on FaultPercentage with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// FaultPercentageMultiError, or nil if none found.
func (m *FaultPercentage) ValidateAll() error {
	return m.validate(true)
}

func (m *FaultPercentage) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if val := m.GetPercentage(); val <= 0 || val > 1000000 {
		err := FaultPercentageValidationError{
			field:  "Percentage",
			reason: "value must be inside range (0, 1000000]",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	// no validation rules for Denominator

	if len(errors) > 0 {
		return FaultPercentageMultiError(errors)
	}
	return nil
}

// FaultPercentageMultiError is an error wrapping multiple validation errors
// returned by FaultPercentage.ValidateAll() if the designated constraints
// aren't met.
type FaultPercentageMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m FaultPercentageMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m FaultPercentageMultiError) AllErrors() []error { return m }

// FaultPercentageValidationError is the validation error returned by
// FaultPercentage.Validate if the designated constraints aren't met.
type FaultPercentageValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e FaultPercentageValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e FaultPercentageValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e FaultPercentageValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e FaultPercentageValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e FaultPercentageValidationError) ErrorName() string { return "FaultPercentageValidationError" }

// Error satisfies the builtin error interface
func (e FaultPercentageValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sFaultPercentage.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = FaultPercentageValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = FaultPercentageValidationError{}

// Validate checks the field values on FaultAbortStatus with the rules defined
// in the proto definition for this message. If any rules are violated, the
// first error encountered is returned, or nil if there are no violations.
func (m *FaultAbortStatus) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on FaultAbortStatus with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// FaultAbortStatusMultiError, or nil if none found.
func (m *FaultAbortStatus) ValidateAll() error {
	return m.validate(true)
}

func (m *FaultAbortStatus) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if val := m.GetHttpStatusCode(); val <= 99 || val >= 600 {
		err := FaultAbortStatusValidationError{
			field:  "HttpStatusCode",
			reason: "value must be inside range (99, 600)",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if len(errors) > 0 {
		return FaultAbortStatusMultiError(errors)
	}
	return nil
}

// FaultAbortStatusMultiError is an error wrapping multiple validation errors
// returned by FaultAbortStatus.ValidateAll() if the designated constraints
// aren't met.
type FaultAbortStatusMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m FaultAbortStatusMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m FaultAbortStatusMultiError) AllErrors() []error { return m }

// FaultAbortStatusValidationError is the validation error returned by
// FaultAbortStatus.Validate if the designated constraints aren't met.
type FaultAbortStatusValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e FaultAbortStatusValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e FaultAbortStatusValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e FaultAbortStatusValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e FaultAbortStatusValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e FaultAbortStatusValidationError) ErrorName() string { return "FaultAbortStatusValidationError" }

// Error satisfies the builtin error interface
func (e FaultAbortStatusValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sFaultAbortStatus.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = FaultAbortStatusValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = FaultAbortStatusValidationError{}

// Validate checks the field values on FaultLatencyDuration with the rules
// defined in the proto definition for this message. If any rules are
// violated, the first error encountered is returned, or nil if there are no violations.
func (m *FaultLatencyDuration) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on FaultLatencyDuration with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// FaultLatencyDurationMultiError, or nil if none found.
func (m *FaultLatencyDuration) ValidateAll() error {
	return m.validate(true)
}

func (m *FaultLatencyDuration) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	if m.GetFixedDurationMs() <= 0 {
		err := FaultLatencyDurationValidationError{
			field:  "FixedDurationMs",
			reason: "value must be greater than 0",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if len(errors) > 0 {
		return FaultLatencyDurationMultiError(errors)
	}
	return nil
}

// FaultLatencyDurationMultiError is an error wrapping multiple validation
// errors returned by FaultLatencyDuration.ValidateAll() if the designated
// constraints aren't met.
type FaultLatencyDurationMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m FaultLatencyDurationMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m FaultLatencyDurationMultiError) AllErrors() []error { return m }

// FaultLatencyDurationValidationError is the validation error returned by
// FaultLatencyDuration.Validate if the designated constraints aren't met.
type FaultLatencyDurationValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e FaultLatencyDurationValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e FaultLatencyDurationValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e FaultLatencyDurationValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e FaultLatencyDurationValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e FaultLatencyDurationValidationError) ErrorName() string {
	return "FaultLatencyDurationValidationError"
}

// Error satisfies the builtin error interface
func (e FaultLatencyDurationValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sFaultLatencyDuration.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = FaultLatencyDurationValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = FaultLatencyDurationValidationError{}
